#include "TrayClientMethod.h"

#include <QDebug>

TrayClientMethod& TrayClientMethod::getInstance()
{
    static TrayClientMethod instance;
    return instance;
}

void TrayClientMethod::setManager(std::shared_ptr<TrayClientManager> manager)
{
    m_pClientManager = manager;
}

void TrayClientMethod::setValue(int type, int idx, int value)
{
    if (m_pClientManager)
        m_pClientManager->setValue(type, idx, value);
}

void TrayClientMethod::setIcon(int type, const QIcon &icon)
{
    if (m_pClientManager)
        m_pClientManager->setIcon(type, 1, icon);
}

void TrayClientMethod::setChecked(int type, bool checked)
{
//    if (m_pClientManager)
//        m_pClientManager->setChecked(type, checked);
//    else {
//        qDebug() << "m_pClientManager is null, pluse init client manager!";
//    }
}

void TrayClientMethod::setCurrentIndex(int idx)
{
    if (m_pClientManager)
        m_pClientManager->setCurrentIndex(idx);
}

void TrayClientMethod::addDeviceItem(int type, const ClientDeviceInfo& info)
{
    if (m_pClientManager)
        m_pClientManager->addDevicePortItem(type, info);
}

void TrayClientMethod::removeDeviceItem(const QString& portName, const QString& devName)
{
    if (m_pClientManager)
        m_pClientManager->removeDevicePortItem(portName, devName);
}

void TrayClientMethod::addAppItem(int idx, const QString& iconName, const QString& descName)
{
    if (m_pClientManager)
        m_pClientManager->addAppItem(idx, iconName, descName);
}

void TrayClientMethod::removeAppItem(int idx)
{
    if (m_pClientManager)
        m_pClientManager->removeAppItem(idx);
}

void TrayClientMethod::updateDescription(const QString& input, const QString& output)
{
    if (m_pClientManager)
        m_pClientManager->updateDescription(input, output);
}
